﻿using MindFusion.Diagramming;
using MindFusion.Diagramming.WinForms;
using MindFusion.Diagramming.WinForms.Behaviors;

namespace Defaults
{
	class MyBehavior: ModifyBehavior
	{
		protected internal MyBehavior(DiagramView diagramView) : base(diagramView)
		{
		}

		public override InteractionState StartDraw(System.Drawing.PointF point)
		{
			int handle = 0;

			// this avoids a null-ref exception
			if (!(Diagram.ActiveItem != null && Diagram.ActiveItem.HitTestHandle(point, ref handle)))
				return base.StartDraw(point);

			DiagramNode item = new TableNode(base.Diagram);
			item.HandlesStyle = HandlesStyle.EasyMove;
			item.SetBounds(((DiagramNode)base.Diagram.ActiveItem).Bounds, false, false);
			base.Diagram.Items.Add(item);

			// this leaves selection in incorrect state (Nodes still contains the node)
			// base.Diagram.Selection.Items.Clear();

			base.Diagram.Selection.Clear();

			item.Selected = true;
			base.Diagram.ActiveItem = item;
			item.ZTop(false);

			DiagramItem activeItem = base.Diagram.ActiveItem;
			if ((!activeItem.NotInteractive()) && activeItem.HitTestHandle(point, ref handle))
			{
				return new InteractionState(activeItem, handle, Action.Modify);
			}
			return new InteractionState(base.Diagram.Selection, -1, Action.Create);
		}
	}
}
